CREATE TABLE category  (
    id SERIAL PRIMARY KEY,
    name VARCHAR
);

create table article (
    id serial,
    name varchar,
    preis numeric,
    beschreibung varchar,
    categoryId INTEGER null,
    FOREIGN KEY (categoryId) REFERENCES category(id)
);

ALTER TABLE
    article
ADD
    PRIMARY KEY (id);

create table einkaufliste (
    id serial,
    name varchar,
    beschreibung varchar,
    erstellungsDatum date
);

ALTER table
    einkaufliste
add
    PRIMARY KEY (id);

create table mengeRealtation (
    id serial,
    articleId INTEGER,
    einkauflisteId INTEGER,
    menge INTEGER,
    PRIMARY key (articleId, einkauflisteId),
    constraint articleFK foreign key (articleId) references article(id) on delete cascade,
    constraint einkauflisteIdFK foreign key (einkauflisteId) references einkaufliste(id) on delete cascade
);


INSERT INTO category (name) VALUES 
('Electronics'),
('Clothing'),
('Furniture'),
('Groceries'),
('Books'),
('Toys'),
('Office Supplies'),
('Home Appliances'),
('Sports Equipment'),
('Automotive Parts'),
('Beauty Products'),
('Health Products'),
('Gardening Supplies'),
('Pet Supplies'),
('Kitchenware'),
('Jewelry'),
('Footwear'),
('Tools and Hardware'),
('Beverages'),
('Cleaning Supplies');

INSERT INTO article (name, preis, beschreibung, categoryId) VALUES
('Laptop', 899.99, '15-inch laptop with 8GB RAM and 256GB SSD', 1),
('T-Shirt', 19.99, 'Cotton t-shirt, size M', 2), 
('Sofa', 499.99, '3-seater sofa in grey color', 3), 
('Apples', 2.99, '1kg of fresh apples', 4),
('Science Fiction Novel', 14.99, 'A popular sci-fi novel', 5); 

INSERT INTO einkaufliste (name, beschreibung, erstellungsDatum) VALUES
('Weekly Groceries', 'Groceries for the week', '2024-11-01'),
('Office Supplies Order', 'Supplies needed for office', '2024-11-05'),
('Home Improvement', 'Items for home renovation', '2024-11-10');

INSERT INTO mengeRealtation (articleId, einkauflisteId, menge) VALUES
(1, 2, 1), 
(2, 2, 5), 
(3, 3, 1), 
(4, 1, 3),
(5, 1, 2);