"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CategoryController = void 0;
const getArticlesInCategory_1 = require("../db/Category/getArticlesInCategory");
const getAllCatergories_1 = require("../db/Category/getAllCatergories");
class CategoryController {
    getAllCategories() {
        return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield (0, getAllCatergories_1.getAllCategories)();
                res.json(response);
            }
            catch (error) {
                next(error);
            }
        });
    }
    getArticlesInCategory() {
        return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
            const categoryId = Number(req.params.categoryId);
            try {
                const response = yield (0, getArticlesInCategory_1.getArticlesInCategory)(categoryId);
                res.json(response);
            }
            catch (error) {
                next(error);
            }
        });
    }
}
exports.CategoryController = CategoryController;
