"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrderManager = void 0;
const getItemsInOrder_1 = require("../db/order/getItemsInOrder");
const addOrderToShoppingCart_1 = require("../db/order/addOrderToShoppingCart");
const updateQuantity_1 = require("../db/order/updateQuantity");
const deleteItemFromShoppingCart_1 = require("../db/order/deleteItemFromShoppingCart");
class OrderManager {
    constructor() { }
    addArticleToShoppingCart() {
        return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
            let itemId = req.body.itemId;
            let shoppingCartId = req.body.cartId;
            let menge = req.body.quantity;
            let id;
            try {
                id = yield (0, addOrderToShoppingCart_1.addOrderToShoppingCart)(itemId, shoppingCartId, menge);
            }
            catch (error) {
                next(error);
                return;
            }
            res.json({
                message: "item has been added",
                id: id,
            });
        });
    }
    getItemsInCart() {
        return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
            let cartId = req.query.cartId;
            let result;
            try {
                result = yield (0, getItemsInOrder_1.getItemsInOrder)(Number(cartId));
            }
            catch (err) {
                next(err);
                return;
            }
            res.json(result);
        });
    }
    updateItemQuantity() {
        return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
            let cartId = req.body.cartId;
            let quantity = req.body.newQuantity;
            let articleId = req.body.articleId;
            try {
                yield (0, updateQuantity_1.updateQuantityItem)(Number(cartId), Number(articleId), Number(quantity));
            }
            catch (error) {
                next(error);
                return;
            }
            res.json({
                message: quantity > 0 ? "the order is updated " : "order deleted "
            });
        });
    }
    deleteItemFromShoppingCart() {
        return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
            const itemId = req.body.itemId;
            const cartId = req.body.cartId;
            try {
                yield (0, deleteItemFromShoppingCart_1.deleteItemFromShoppingCart)(Number(itemId), Number(cartId));
            }
            catch (error) {
                next(error);
                return;
            }
            res.json({
                message: "Item has been removed from the shopping cart",
            });
        });
    }
}
exports.OrderManager = OrderManager;
