"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addNewArticle = void 0;
const CustomError_1 = require("../../error/CustomError");
const connect_1 = require("../connect");
const addNewArticle = (preis, beschreibung, name, categoryId) => __awaiter(void 0, void 0, void 0, function* () {
    const query = `
  INSERT INTO article (preis, beschreibung, name,categoryId)
  VALUES ($1, $2, $3,$4)
  RETURNING id 
`;
    let id = -1;
    let db = new connect_1.DB();
    let client = db.Client;
    const values = [preis, beschreibung, name, categoryId];
    let result = yield client
        .query(query, values)
        .then((res) => {
        id = res.rows[0].id;
    })
        .catch((err) => {
        throw new CustomError_1.CustomError("we can't connnect to the database ", 500, "NO_DATABASE_CONNECTION", "NO_MORE_DETAILS");
    })
        .finally(() => {
        db.destroy();
    });
    return id;
});
exports.addNewArticle = addNewArticle;
