"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getArticleByCriteria = void 0;
const CustomError_1 = require("../../error/CustomError");
const connect_1 = require("../connect");
const getArticleByCriteria = (criteria, querySelector) => __awaiter(void 0, void 0, void 0, function* () {
    const query = `
        select * 
        from article 
        where ${criteria} = $1
        `;
    let values = [querySelector];
    let result = [];
    let db = new connect_1.DB();
    let client = db.Client;
    yield client
        .query(query, values)
        .then((res) => {
        result = res.rows;
        if (res.rows.length <= 0) {
            throw new CustomError_1.CustomError("with the provided Criteria there is No article ", 404, "NO_ARTICLE_FOUND", "NO_MORE_DETAILS");
        }
    })
        .catch((err) => {
        if (err instanceof CustomError_1.CustomError) {
            throw err;
        }
        else {
            throw new CustomError_1.CustomError("we can't connnect to the database ", 500, "NO_DATABASE_CONNECTION", "NO_MORE_DETAILS");
        }
    })
        .finally(() => {
        db.destroy();
    });
    return result;
});
exports.getArticleByCriteria = getArticleByCriteria;
