"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateArticle = updateArticle;
const connect_1 = require("../../db/connect");
const getArticleByCriteria_1 = require("./getArticleByCriteria");
const CustomError_1 = require("../../error/CustomError");
function updateArticle(articleId, newArticle) {
    return __awaiter(this, void 0, void 0, function* () {
        let obj = yield (0, getArticleByCriteria_1.getArticleByCriteria)("id", articleId);
        let db = new connect_1.DB();
        let client = db.Client;
        let query = `update article set 
    name = $1,
    preis = $2, 
    beschreibung = $3 
    where id = $4
    `;
        const values = [newArticle.name, newArticle.preis, newArticle.beschreibung, newArticle.id];
        let IsUpdated = false;
        yield client.query(query, values)
            .then((res) => {
            if (res.rowCount > 0) {
                IsUpdated = true;
            }
        })
            .catch((err) => {
            console.log(err);
            throw new CustomError_1.CustomError(`we can't update the article with the id ${newArticle.id}`, 500, "no code", "no details ");
        }).finally(() => {
            db.destroy();
        });
        return IsUpdated;
    });
}
