"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateQuantityItem = void 0;
const CustomError_1 = require("../../error/CustomError");
const connect_1 = require("../connect");
const updateQuantityItem = (cartId, articleId, quantity) => __awaiter(void 0, void 0, void 0, function* () {
    let db = new connect_1.DB();
    let client = db.Client;
    if (quantity <= 0) {
        throw new CustomError_1.CustomError("Invalid Quantity", 400, "INVALID_QUANTITY", "Quantity must be greater than 0. If you intend to remove the item, please use the DELETE endpoint.");
    }
    else {
        let updateQuery = "update mengeRealtation set menge = $1 where einkauflisteId = $2 and articleId = $3";
        let updateValues = [quantity, cartId, articleId];
        yield client
            .query(updateQuery, updateValues)
            .then((res) => {
            if (res.rowCount === 0) {
                throw new CustomError_1.CustomError("Item Not Found", 404, "ITEM_NOT_FOUND", "the cartId or the articleId not correct");
            }
        })
            .catch((err) => {
            throw err;
        })
            .finally(() => {
            db.destroy();
        });
    }
});
exports.updateQuantityItem = updateQuantityItem;
