"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createShoppingCart = void 0;
const connect_1 = require("../connect");
const createShoppingCart = (body) => __awaiter(void 0, void 0, void 0, function* () {
    let id = -1;
    let date = new Date();
    let db = new connect_1.DB();
    let client = db.Client;
    const query = "insert into einkaufliste (name,beschreibung,erstellungsDatum) values ($1,$2,$3) RETURNING id";
    let values = [body.name, body.beschreibung, date];
    yield client
        .query(query, values)
        .then((res) => {
        id = res.rows[0].id;
    })
        .catch((err) => {
        throw new Error("we cant create the shopping cart  ");
    })
        .finally(() => {
        db.destroy();
    });
    return id;
});
exports.createShoppingCart = createShoppingCart;
