"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteShoppingCart = void 0;
const connect_1 = require("../connect");
const CustomError_1 = require("../../error/CustomError");
const deleteShoppingCart = (id) => __awaiter(void 0, void 0, void 0, function* () {
    let db = new connect_1.DB();
    let client = db.Client;
    const query = "DELETE FROM einkaufliste WHERE id = $1";
    const values = [id];
    yield client
        .query(query, values)
        .then((res) => {
        if (res.rowCount === 0) {
            throw new CustomError_1.CustomError("Shopping Cart Not Found", 404, "CART_NOT_FOUND", `The shopping cart with id ${id} does not exist.`);
        }
    })
        .catch((err) => {
        throw err;
    })
        .finally(() => {
        db.destroy();
    });
    return true;
});
exports.deleteShoppingCart = deleteShoppingCart;
