"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getShoppingCarteByCriteria = void 0;
const CustomError_1 = require("../../error/CustomError");
const connect_1 = require("../connect");
const getShoppingCarteByCriteria = (criteria, querySelector) => __awaiter(void 0, void 0, void 0, function* () {
    const query = `
        select * 
        from einkaufliste 
        where ${criteria} like $1
        `;
    let values = [`%${querySelector}%`];
    let result = [];
    let db = new connect_1.DB();
    let client = db.Client;
    yield client
        .query(query, values)
        .then((res) => {
        result = res.rows;
        if (result.length === 0) {
            throw new CustomError_1.CustomError("No Items Found in Cart", 404, "CART_EMPTY", `No items were found in the shopping cart matching the criteria '${criteria}' with value '${querySelector}'.`);
        }
    })
        .catch((err) => {
        throw err;
    })
        .finally(() => {
        db.destroy();
    });
    return result;
});
exports.getShoppingCarteByCriteria = getShoppingCarteByCriteria;
