"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getShoppingListContainingItemByName = exports.getShoppingListContainingItemById = void 0;
const connect_1 = require("../connect");
const getShoppingListContainingItemById = (id) => __awaiter(void 0, void 0, void 0, function* () {
    let db = new connect_1.DB();
    let client = db.Client;
    const query = `select * 
                from mengeRealtation m
                join article a on a.id = m.articleId 
                join einkaufliste e on e.id = m.einkauflisteId
                where articleId = $1 `;
    const value = [id];
    try {
        const response = yield client.query(query, value);
        return response.rows;
    }
    catch (err) {
        throw err;
    }
});
exports.getShoppingListContainingItemById = getShoppingListContainingItemById;
const getShoppingListContainingItemByName = (name) => __awaiter(void 0, void 0, void 0, function* () {
    let db = new connect_1.DB();
    let client = db.Client;
    const query = `select * 
                  from mengeRealtation m
                  join article a on a.id = m.articleId 
                  join einkaufliste e on e.id = m.einkauflisteId
                  where a.name = $1 `;
    const value = [name];
    try {
        const response = yield client.query(query, value);
        return response.rows;
    }
    catch (err) {
        throw err;
    }
});
exports.getShoppingListContainingItemByName = getShoppingListContainingItemByName;
