"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorMiddleWare = void 0;
const CustomError_1 = require("../../error/CustomError");
const errorMiddleWare = (err, req, res, next) => {
    let errorDetails;
    if (err instanceof CustomError_1.CustomError) {
        const rawString = err.details;
        errorDetails = JSON.parse(rawString);
    }
    res.status(err.status || 500).json({
        message: err.message,
        code: err.code || "noCode",
        details: err instanceof CustomError_1.CustomError ? errorDetails : "no Details",
    });
};
exports.errorMiddleWare = errorMiddleWare;
