"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.check = void 0;
const getProductByCriteria_1 = require("./validityCheck/articleCheck/getProductByCriteria");
const addProductChecker_1 = require("./validityCheck/articleCheck/addProductChecker");
const createShoppingCartChecker_1 = require("./validityCheck/shoppingCartCheck/createShoppingCartChecker");
const getShoppingCartByCriteria_1 = require("./validityCheck/shoppingCartCheck/getShoppingCartByCriteria");
const orderChecker_1 = require("./validityCheck/orderCheck/orderChecker");
const updateArticleChecker_1 = require("./validityCheck/articleCheck/updateArticleChecker");
const deleteArticleChecker_1 = require("./validityCheck/articleCheck/deleteArticleChecker");
const UpdateShoppingCartChecker_1 = require("./validityCheck/shoppingCartCheck/UpdateShoppingCartChecker");
const DeleteShoppingCartChecker_1 = require("./validityCheck/shoppingCartCheck/DeleteShoppingCartChecker");
const QueryIdChecker_1 = require("./validityCheck/shoppingCartCheck/QueryIdChecker");
const CatergoryParamsIdChecker_1 = require("./validityCheck/Category/CatergoryParamsIdChecker");
const ValidityCheker_1 = require("./validityCheck/ValidityCheker");
const queryParamsSchema_1 = require("./validityCheck/utils/queryParamsSchema");
const check = (req, res, next) => {
    let validityChecker = null;
    let checker;
    let path = req.path;
    if (path == "/addArticle") {
        checker = new ValidityCheker_1.ValidityChecker(addProductChecker_1.addProductSchema, req.body);
    }
    if (path == "/getProductByCriteria") {
        let body = Object.assign({}, req.query);
        try {
            checker = new ValidityCheker_1.ValidityChecker(queryParamsSchema_1.queryParamsSchema, body);
            console.log("m here");
            const isValid = checker.validate();
            if (isValid) {
                let criteria = Object.keys(body)[0];
                req.params.selector = criteria;
                req.params.value = String(body[criteria]);
            }
        }
        catch (err) {
            next(err);
            return;
        }
        validityChecker = new getProductByCriteria_1.getProductByCriteriaChecker(body);
        if (validityChecker.check()) {
            let criteria = Object.keys(body)[0];
            req.params.selector = criteria;
            req.params.value = String(body[criteria]);
        }
    }
    if (path === "/updateArticle") {
        checker = new ValidityCheker_1.ValidityChecker(updateArticleChecker_1.updateProductSchema, req.body);
    }
    if (path === "/deleteArticle") {
        checker = new ValidityCheker_1.ValidityChecker(deleteArticleChecker_1.deleteArticleSchema, req.query);
    }
    if (path === "/createShoppingCart") {
        let body = req.body;
        validityChecker = new createShoppingCartChecker_1.addShoppingCartChecker(body);
        checker = new ValidityCheker_1.ValidityChecker(createShoppingCartChecker_1.addShoppingCartSchema, body);
    }
    if (path === "/getShoppingCartByCriteria") {
        let body = Object.assign({}, req.query);
        validityChecker = new getShoppingCartByCriteria_1.getShoppingCartByCriteriaChecker(body);
        if (validityChecker.check()) {
            let criteria = Object.keys(body)[0];
            req.params.selector = criteria;
            req.params.value = String(body[criteria]);
        }
    }
    if (path === "/updateShoppingCart") {
        let body = req.body;
        validityChecker = new UpdateShoppingCartChecker_1.UpdateShoppingCartChecker(body);
        checker = new ValidityCheker_1.ValidityChecker(UpdateShoppingCartChecker_1.updateShoppingCartSchema, body);
    }
    if (path === "/deleteShoppingCart") {
        let body = { id: Number(req.query.id) };
        validityChecker = new DeleteShoppingCartChecker_1.DeleteShoppingCartChecker(body);
        checker = new ValidityCheker_1.ValidityChecker(DeleteShoppingCartChecker_1.deleteShoppingCartSchema, body);
    }
    if (path === "/addNewItemToOrder") {
        validityChecker = new orderChecker_1.AddNewItemToOrderChecker(req.body);
        checker = new ValidityCheker_1.ValidityChecker(orderChecker_1.addItemSchema, req.body);
    }
    if (path === "/getItemsInCart") {
        validityChecker = new orderChecker_1.GetItemsInCartChecker(req.query);
        checker = new ValidityCheker_1.ValidityChecker(orderChecker_1.getItemsSchema, req.query);
    }
    if (path === "/updateProductQuantity") {
        validityChecker = new orderChecker_1.UpdateProductMengeChecker(req.body);
        checker = new ValidityCheker_1.ValidityChecker(orderChecker_1.updateProductQuantitySchema, req.body);
    }
    if (path === "/deleteItemFromShoppingCart") {
        validityChecker = new orderChecker_1.DeleteItemFromCartChecker(req.body);
        checker = new ValidityCheker_1.ValidityChecker(orderChecker_1.deleteItemSchema, req.body);
    }
    if (path === "/getShoppingListContainingItemById") {
        validityChecker = new QueryIdChecker_1.QueryIdChecker(req.query);
        checker = new ValidityCheker_1.ValidityChecker(QueryIdChecker_1.queryIdSchema, req.query);
    }
    if (path === "/getShoppingListContainingItemByName") {
        validityChecker = new QueryIdChecker_1.QueryNameChecker(req.query);
        checker = new ValidityCheker_1.ValidityChecker(QueryIdChecker_1.queryNameSchema, req.query);
    }
    const regex = /^\/categories\/\d+\/articles$/;
    if (regex.test(path)) {
        validityChecker = new CatergoryParamsIdChecker_1.CategoryParamsIdChecker(req.params);
        checker = new ValidityCheker_1.ValidityChecker(CatergoryParamsIdChecker_1.categoryParamsIdSchema, req.params);
    }
    let isValidApiCall = false;
    try {
        isValidApiCall = checker.validate();
    }
    catch (error) {
        next(error);
        return;
    }
    isValidApiCall
        ? next()
        : res.status(404).json({ message: "u have sent something undefined " });
};
exports.check = check;
