"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.categoryParamsIdSchema = exports.CategoryParamsIdChecker = void 0;
const CustomError_1 = require("../../../error/CustomError");
const checkerInterface_1 = require("../../../middleware/checkerInterface");
class CategoryParamsIdChecker extends checkerInterface_1.Checker {
    constructor(params) {
        super();
        this.params = params;
    }
    check() {
        const keys = Object.keys(this.params);
        if (keys.length != 1) {
            throw new CustomError_1.CustomError("unapropriate count of params ", 422, "Unprocessable Entity", "u sent " + String(...keys) + "but u have to send only categoryId");
        }
        const key = keys.find((item) => item == "categoryId");
        if (!key) {
            throw new CustomError_1.CustomError("missed categoryId  params", 422, "Unprocessable Entity", "u sent " + String(...keys));
        }
        return true;
    }
}
exports.CategoryParamsIdChecker = CategoryParamsIdChecker;
const zod_1 = require("zod");
exports.categoryParamsIdSchema = zod_1.z
    .object({
    categoryId: zod_1.z
        .number()
        .int()
        .positive({ message: "categoryId must be a positive integer." })
        .catch((err) => {
        throw new CustomError_1.CustomError("Invalid categoryId", 422, "INVALID_CATEGORY_ID", err.error.message);
    }),
})
    .strict()
    .catch((err) => {
    const keys = Object.keys(err.input || {});
    throw new CustomError_1.CustomError("Unexpected fields in params", 422, "UNEXPECTED_FIELDS", err.error.message);
});
