"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.queryParamsSchema = void 0;
const CustomError_1 = require("../../../error/CustomError");
const zod_1 = require("zod");
exports.queryParamsSchema = zod_1.z
    .object({
    name: zod_1.z.string({ message: "name must be a string" }).optional(),
    id: zod_1.z
        .number()
        .optional()
        .catch((err) => {
        throw new CustomError_1.CustomError("id has tobe number", 422, "Unaccesable_entity", err.error.message);
    }),
})
    .refine((data) => Object.keys(data).length === 1, {
    message: "only one key (name, id ) is allowed at a time",
})
    .catch((err) => {
    throw new CustomError_1.CustomError("id has tobe number", 422, "Unaccesable_entity", err.error.message);
});
