"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = require("express");
const articleRouter_1 = __importDefault(require("./articleRouter"));
const shoppingCartRouter_1 = __importDefault(require("./shoppingCartRouter"));
const orderRoutes_1 = __importDefault(require("./orderRoutes"));
const errorMiddleware_1 = require("../middleware/Error/errorMiddleware");
const categoryRouter_1 = __importDefault(require("./categoryRouter"));
const router = (0, express_1.Router)();
router.use("/article", articleRouter_1.default);
router.use("/shoppingCart", shoppingCartRouter_1.default);
router.use("/order", orderRoutes_1.default);
router.use("/category", categoryRouter_1.default);
router.use(errorMiddleware_1.errorMiddleWare);
exports.default = router;
