"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = require("express");
const shoppingCartController_1 = require("../controller/shoppingCartController");
const check_1 = require("../middleware/check");
const router = (0, express_1.Router)();
let controller = new shoppingCartController_1.ShoppingCartController();
router.post("/createShoppingCart", check_1.check, controller.createShoppingCart());
router.get("/getAllShoppingCart", controller.getAllShoppingCart());
router.get("/getShoppingCartByCriteria", check_1.check, controller.getShoppingCarteByCriteria());
router.get("/getShoppingListContainingItemById", check_1.check, controller.getShoppingListContainingItemById());
router.get("/getShoppingListContainingItemByName", check_1.check, controller.getShoppingListContainingItemByName());
router.put("/updateShoppingCart", check_1.check, controller.updateShoppingCart());
router.delete("/deleteShoppingCart", check_1.check, controller.deleteShoppingCart());
exports.default = router;
