"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const globals_1 = require("@jest/globals");
const supertest_1 = __importDefault(require("supertest"));
const baseUrl = "http://localhost:8000";
(0, globals_1.describe)("product", () => {
    let id;
    (0, globals_1.describe)("add Product", () => {
        (0, globals_1.it)("should send back status 201", () => __awaiter(void 0, void 0, void 0, function* () {
            const payload = {
                "preis": 2,
                "beschreibung": " the best beschriebung ",
                "name": "usefull name",
                "categoryId": 1
            };
            const res = yield (0, supertest_1.default)(baseUrl)
                .post("/api/article/addArticle")
                .send(payload)
                .set("Content-Type", "application/json")
                .set('Accept', 'application/json');
            const returnedStatus = res.status;
            id = res.body.id;
            const expectedStatus = 201;
            (0, globals_1.expect)(expectedStatus).toEqual(returnedStatus);
        }));
    });
    (0, globals_1.describe)(baseUrl, () => {
        (0, globals_1.it)("should send back more than one article ", () => __awaiter(void 0, void 0, void 0, function* () {
            let res = yield (0, supertest_1.default)(baseUrl).get("/api/article/getAllProducts");
            (0, globals_1.expect)(res.status).toEqual(200);
            const returnedLength = res.body.length;
            const EXPECTED_VALUE = 1;
            (0, globals_1.expect)(returnedLength).toBeGreaterThanOrEqual(EXPECTED_VALUE);
        }));
    });
    (0, globals_1.describe)(baseUrl, () => {
        (0, globals_1.it)(` should update the article with the id ${id} `, () => __awaiter(void 0, void 0, void 0, function* () {
            let res = yield (0, supertest_1.default)(baseUrl).put("/api/article/updateArticle").send({
                id: id,
                name: "other name ",
                preis: 5,
                beschreibung: "other Description"
            });
            const EXPECTED_STATUS = 204;
            const returnedStatus = res.status;
            (0, globals_1.expect)(EXPECTED_STATUS).toEqual(returnedStatus);
        }));
    });
    (0, globals_1.describe)(baseUrl, () => {
        (0, globals_1.it)("should delete the added article", () => __awaiter(void 0, void 0, void 0, function* () {
            let res = yield (0, supertest_1.default)(baseUrl).delete(`/api/article/deleteArticle?id=${id}`);
            let returnedStatus = res.status;
            let ExpectedStatus = 204;
            (0, globals_1.expect)(ExpectedStatus).toEqual(returnedStatus);
        }));
    });
});
