"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const globals_1 = require("@jest/globals");
const supertest_1 = __importDefault(require("supertest"));
const baseUrl = "http://localhost:8000";
(0, globals_1.describe)("test for categories", () => {
    (0, globals_1.describe)("get all categories", () => {
        const response = (0, supertest_1.default)(baseUrl).get("/api/category/getAllCategories");
        (0, globals_1.it)("should send a response status 200", () => __awaiter(void 0, void 0, void 0, function* () {
            const status = (yield response).status;
            const expectedStatus = 200;
            (0, globals_1.expect)(expectedStatus).toEqual(status);
        }));
        (0, globals_1.it)("should return moore than one category", () => __awaiter(void 0, void 0, void 0, function* () {
            (0, globals_1.expect)((yield response).body.length > 0);
        }));
    });
    (0, globals_1.describe)("get article in a certain catgeory", () => {
        const response = (0, supertest_1.default)(baseUrl)
            .get("/api/category/categories/3/articles")
            .accept("application/json");
        (0, globals_1.it)("should get exactly get one article sotred in category Furniture ", () => __awaiter(void 0, void 0, void 0, function* () {
            const body = (yield response).body;
            (0, globals_1.expect)(body.length).toEqual(1);
        }));
        (0, globals_1.it)("expect categoryId is 3", () => __awaiter(void 0, void 0, void 0, function* () {
            const body = (yield response).body;
            (0, globals_1.expect)(body[0].categoryid).toEqual(3);
        }));
        (0, globals_1.it)("expect name is Sofa", () => __awaiter(void 0, void 0, void 0, function* () {
            const body = (yield response).body;
            (0, globals_1.expect)(body[0].name).toEqual("Sofa");
        }));
    });
});
