import { getArticlesInCategory } from "../db/Category/getArticlesInCategory";
import { getAllCategories } from "../db/Category/getAllCatergories";
import { NextFunction, Request, Response } from "express";

export class CategoryController {
  public getAllCategories() {
    return async (req: Request, res: Response, next: NextFunction) => {
      try {
        const response = await getAllCategories();
        res.json(response);
      } catch (error) {
        next(error);
      }
    };
  }

  public getArticlesInCategory() {
    return async (req: Request, res: Response, next: NextFunction) => {
      const categoryId = Number(req.params.categoryId);
      try {
        const response = await getArticlesInCategory(categoryId);
        res.json(response);
      } catch (error) {
        next(error);
      }
    };
  }
}
