import { getItemsInOrder } from "../db/order/getItemsInOrder";
import { addOrderToShoppingCart } from "../db/order/addOrderToShoppingCart";
import { Response, Request, NextFunction } from "express";
import { updateQuantityItem } from "../db/order/updateQuantity";
import { deleteItemFromShoppingCart } from "../db/order/deleteItemFromShoppingCart";

export class OrderManager {
  constructor() { }
  addArticleToShoppingCart() {
    return async (req: Request, res: Response, next: NextFunction) => {
      let itemId = req.body.itemId;
      let shoppingCartId = req.body.cartId;
      let menge = req.body.quantity;
      let id
      try {
        id = await addOrderToShoppingCart(itemId, shoppingCartId, menge);
      } catch (error) {
        next(error);
        return;
      }

      res.json({
        message: "item has been added",
        id: id,
      });
    };
  }

  public getItemsInCart() {
    return async (req: Request, res: Response, next: NextFunction) => {
      let cartId = req.query.cartId;
      let result;
      try {
        result = await getItemsInOrder(Number(cartId));
      } catch (err) {
        next(err);
        return;
      }

      res.json(result);
    };
  }

  public updateItemQuantity() {
    return async (req: Request, res: Response, next: NextFunction) => {
      let cartId = req.body.cartId;
      let quantity = req.body.newQuantity;
      let articleId = req.body.articleId;
      try {
        await updateQuantityItem(Number(cartId), Number(articleId), Number(quantity));
      } catch (error: any) {
        next(error);
        return;
      }
      res.json({
        message: quantity > 0 ? "the order is updated " : "order deleted "
      })
    }
  }

  public deleteItemFromShoppingCart() {
    return async (req: Request, res: Response, next: NextFunction) => {
      const itemId = req.body.itemId;
      const cartId = req.body.cartId;

      try {
        await deleteItemFromShoppingCart(Number(itemId), Number(cartId));
      } catch (error) {
        next(error);
        return;
      }

      res.json({
        message: "Item has been removed from the shopping cart",
      });
    };
  }
}
