import { CustomError } from "../../error/CustomError";
import { DB } from "../connect";

export const addNewArticle = async (
  preis: number,
  beschreibung: string,
  name: string,
  categoryId :number ,
): Promise<number> => {
  const query = `
  INSERT INTO article (preis, beschreibung, name,categoryId)
  VALUES ($1, $2, $3,$4)
  RETURNING id 
`;

  let id = -1;

  let db = DB.getDB( );
  let client = db.Client;

  const values = [preis, beschreibung, name,categoryId];

  let result = await client
    .query(query, values)
    .then((res) => {
      id = res.rows[0].id;
    })
    .catch((err) => {
      throw new CustomError("we can't connnect to the database ", 500, "NO_DATABASE_CONNECTION", "NO_MORE_DETAILS");
    })
  return id;
};
