import { CustomError } from "../../error/CustomError";
import { DB } from "../connect";
import { articleObj } from "./getAllArticle";

export const getArticleByCriteria = async (
  criteria: string,
  querySelector: string | number
): Promise<articleObj[]> => {
  const query = `
        select * 
        from article 
        where ${criteria} = $1
        `;
  let values = [querySelector];
  let result: articleObj[] = [];

  let db = DB.getDB( );
  let client = db.Client;

  await client
    .query(query, values)
    .then((res) => {
      result = res.rows;
      if (res.rows.length <= 0) {
        throw new CustomError(
          "with the provided Criteria there is No article ",
          404,
          "NO_ARTICLE_FOUND",
          '[{message: "no article found "}]'
        );
      }
    })
    .catch((err) => {
      if (err instanceof CustomError) {
        throw err;
      } else {
        throw new CustomError(
          "we can't connnect to the database ",
          500,
          "NO_DATABASE_CONNECTION",
          "NO_MORE_DETAILS"
        );
      }
    })

  return result;
};
