import { DB } from "../../db/connect";
import { articleObj } from "./getAllArticle";
import { getArticleByCriteria } from "./getArticleByCriteria";
import { CustomError } from "../../error/CustomError";

export async function updateArticle(articleId: number, newArticle: articleObj):Promise<boolean> {
    let obj = await getArticleByCriteria("id", articleId);

    let db = DB.getDB( );
    let client = db.Client;

    let query = `update article set 
    name = $1,
    preis = $2, 
    beschreibung = $3 
    where id = $4
    `
    const values = [newArticle.name, newArticle.preis, newArticle.beschreibung, newArticle.id];
    let IsUpdated = false ; 

    await client.query(query, values)
        .then((res) => {
            if (res.rowCount!>0) {
                IsUpdated = true ; 
            }
        })
        .catch((err) => {
            console.log(err);
            throw new CustomError(`we can't update the article with the id ${newArticle.id}`, 500, "no code", "no details ");
        })
    return IsUpdated ; 
}