import { CustomError } from "../../error/CustomError";
import { DB } from "../connect";

export const deleteItemFromShoppingCart = async (
  itemId: number,
  cartId: number
) => {
  let db = DB.getDB( );
  let client = db.Client;

  try {
    const deleteQuery = `
      DELETE FROM mengeRealtation
      WHERE articleId = $1 AND einkauflisteId = $2
      RETURNING id
    `;
    const deleteValues = [itemId, cartId];
    const deleteResult = await client.query(deleteQuery, deleteValues);

    if (deleteResult.rowCount === 0) {
      throw new CustomError(
        "Item Not in Cart",
        404,
        "ITEM_NOT_IN_CART",
        `The item with ID ${itemId} is not in the shopping cart with ID ${cartId}.`
      );
    }

    return { message: "Item deleted successfully", id: deleteResult.rows[0].id };

  } catch (err: any) {
    throw err ; 
  } 
};