import { CustomError } from "../../error/CustomError";
import { DB } from "../connect";

export const updateQuantityItem = async (
    cartId: number,
    articleId: number,
    quantity: number
) => {
    let db = DB.getDB( );
    let client = db.Client;

    if (quantity <= 0) {
        throw new CustomError(
            "Invalid Quantity",
            400,
            "INVALID_QUANTITY",
            "Quantity must be greater than 0. If you intend to remove the item, please use the DELETE endpoint."
        );
    } else {
        let updateQuery =
            "update mengeRealtation set menge = $1 where einkauflisteId = $2 and articleId = $3";
        let updateValues = [quantity, cartId, articleId];

        await client
            .query(updateQuery, updateValues)
            .then((res) => {
                if (res.rowCount === 0) {
                    throw new CustomError(
                        "Item Not Found",
                        404,
                        "ITEM_NOT_FOUND",
                        "the cartId or the articleId not correct"
                    );
                }
            })
            .catch((err) => {
                throw err; 
            })
    }
};
