import { DB } from "../connect";

export type shoppingCart = {
  name: string;
  beschreibung: string;
};

export const createShoppingCart = async (body: shoppingCart) => {
  let id = -1;
  let date = new Date();
  let db = DB.getDB( );
  let client = db.Client;

  const query =
    "insert into einkaufliste (name,beschreibung,erstellungsDatum) values ($1,$2,$3) RETURNING id";
  let values = [body.name, body.beschreibung, date];

  await client
    .query(query, values)
    .then((res) => {
      id = res.rows[0].id;
    })
    .catch((err) => {
      throw new Error("we cant create the shopping cart  ");
    })

  return id;
};
