import { DB } from "../connect";
import { CustomError } from "../../error/CustomError";

export const deleteShoppingCart = async (id: number): Promise<boolean> => {
    let db = DB.getDB( );
    let client = db.Client;

    const query = "DELETE FROM einkaufliste WHERE id = $1";
    const values = [id];

    await client
        .query(query, values)
        .then((res) => {
            if (res.rowCount === 0) {
                throw new CustomError(
                    "Shopping Cart Not Found",
                    404,
                    "CART_NOT_FOUND",
                    `The shopping cart with id ${id} does not exist.`
                );
            }
        })
        .catch((err) => {
            throw err;
        })

    return true;
};