import { CustomError } from "error/CustomError";
import { DB } from "../connect";

export const getShoppingListContainingItemById = async (id: number) => {
  let db = DB.getDB( );
  let client = db.Client;

  const query = `select * 
                from mengeRealtation m
                join article a on a.id = m.articleId 
                join einkaufliste e on e.id = m.einkauflisteId
                where articleId = $1 `;
  const value = [id];

  try {
    const response = await client.query(query, value);
    return response.rows;
  } catch (err) {
    throw err;
  }
};

export const getShoppingListContainingItemByName = async (name: string) => {
  let db = DB.getDB( );
  let client = db.Client;
  
    const query = `select * 
                  from mengeRealtation m
                  join article a on a.id = m.articleId 
                  join einkaufliste e on e.id = m.einkauflisteId
                  where a.name = $1 `;
    const value = [name];
  
    try {
      const response = await client.query(query, value);
      return response.rows;
    } catch (err) {
      throw err;
    }
  };
  


