import { CustomError } from "../../error/CustomError";
import { DB } from "../../db/connect";

type shoppingCart = {name:string, beschreibung:string}

export const updateShoppingCart = async (id: number, body: shoppingCart): Promise<boolean> => {
    let db = DB.getDB( );
    let client = db.Client;

    const query = `
      UPDATE einkaufliste
      SET name = $1, beschreibung = $2
      WHERE id = $3
    `;
    const values = [body.name, body.beschreibung, id];

    await client
        .query(query, values)
        .then((res) => {
            if (res.rowCount === 0) {
                throw new CustomError(
                    "Shopping Cart Not Found",
                    404,
                    "CART_NOT_FOUND",
                    `The shopping cart with id ${id} does not exist.`
                );
            }
        })
        .catch((err) => {
            throw err;
        })

    return true;
};
