import { CustomError } from "../../error/CustomError";
import { Request, Response, NextFunction } from "express";

export const errorMiddleWare = (
  err: CustomError | any,
  req: Request,
  res: Response,
  next: NextFunction
) => {
  let errorDetails: string;

  if (err instanceof CustomError) {
    const rawString = err.details;
    try {
      errorDetails = JSON.parse(rawString);
    } catch (error) {
      errorDetails = rawString; 
    }
  }

  res.status(err.status || 500).json({
    message: err.message,
    code: err.code || "noCode",
    details: err instanceof CustomError ? errorDetails! : "no Details",
  });
};
