import { z, ZodSchema } from "zod";

export abstract class ValidityChecker {
  private schema?: ZodSchema;
  private object?: any;

  constructor() {}

  protected setSchema(schema: ZodSchema) {
    this.schema = schema;
  }

  protected setObject(object: any) {
    this.object = object;
  }

  public validate(): boolean {
    try {
      this.schema!.parse(this.object);
    } catch (e) {
      throw e;
    }
    return true;
  }

  abstract validateUsingUrl(): boolean;
}
