import { Request } from "express";
import { ValidityChecker } from "../ValidityCheker";
import { categoryParamsIdSchema } from "./category.schema";



export class CategoryValidityChecker extends ValidityChecker {
  path: string;
  req: Request;

  constructor(path: string, req: Request) {
    super();
    this.path = path;
    this.req = req;
  }

  validateUsingUrl(): boolean {
    const regex = /^\/categories\/\d+\/articles$/;
    if (regex.test(this.path)) {
      this.setSchema(categoryParamsIdSchema);
      this.setObject(this.req.params);
      return this.validate();
    }

    return true;
  }
}
