import { queryIdSchema } from "../shoppingCartCheck/shoppingcart.schema";
import { ValidityChecker } from "../ValidityCheker";
import {
  addItemSchema,
  deleteItemSchema,
  getItemsSchema,
  updateProductQuantitySchema,
} from "./order.schema";
import { Request } from "express";


export class OrderValidityChecker extends ValidityChecker {
  path: string;
  req: Request;

  constructor( path: string, req: Request) {
    super();
    this.path = path;
    this.req = req;
  }

  validateUsingUrl(): boolean {
    if (this.path === "/addNewItemToOrder") {
      this.setSchema(addItemSchema);
      this.setObject(this.req.body);
      return this.validate();
    }

    if (this.path === "/getItemsInCart") {
      this.setSchema(getItemsSchema);
      this.setObject(this.req.query);
      return this.validate();
    }

    if (this.path === "/updateProductQuantity") {
      this.setSchema(updateProductQuantitySchema);
      this.setObject(this.req.body);
      return this.validate();
    }

    if (this.path === "/deleteItemFromShoppingCart") {
      this.setSchema(deleteItemSchema);
      this.setObject(this.req.body);
      return this.validate();
    }

    if (this.path === "/getShoppingListContainingItemById") {
      this.setSchema(queryIdSchema);
      this.setObject(this.req.query);
      return this.validate();
    }

    return true;
  }
}
