import { CustomError } from "../../../error/CustomError";
import { z } from "zod";

export const queryParamsSchema = z
  .object({
    name: z.string({ message: "name must be a string" }).optional(),
    id: z
      .string().refine((data)=>{
        const regex = /[0-9]+/ ; 
        return regex.test(data) && Number(data)>=0 ; 
      })
      .optional()
      .catch((err) => {
        throw new CustomError(
          "id has to be number",
          422,
          "Unaccesable_entity",
          err.error.message
        );
      }),
  })
  .refine((data) => Object.keys(data).length === 1, {
    message: "only one key (name, id ) is allowed at a time",
  })
  .catch((err) => {
    throw new CustomError(
      "wrong prarams ",
      422,
      "Unaccesable_entity",
      err.error.message
    );
  });
