import { Router } from "express";
import { IRouter } from "./RouterInterface";

export class RouterAssembler {
  public assembledRouter: Router;
  private routerArray: IRouter[];
  constructor(routerArray: IRouter[]) {
    this.assembledRouter = Router();
    this.routerArray = routerArray;
  }

  assembleRoutes() {
    this.routerArray.forEach((router: IRouter) => {
      router.registerRoutes();
      this.assembledRouter.use(router.routerSubPath, router.router);
    });
  }
}
