import { articleController } from "../controller/articleController";
import { Router } from "express";
import { check } from "../middleware/check";
import { IRouter } from "./RouterInterface";

export class ArticleRouter implements IRouter {
  public router: Router;
  public routerSubPath: string = "/article";
  private controller: articleController;

  constructor() {
    this.router = Router();
    this.controller = new articleController();
  }

  public registerRoutes(): void {
    this.router.post("/addArticle", check, this.controller.addArticle());

    this.router.get("/getProductByCriteria", check, this.controller.getProductByCriteria());

    this.router.get("/getAllProducts", this.controller.getAllArticle());

    this.router.put("/updateArticle", check, this.controller.updateArticle());

    this.router.delete("/deleteArticle", check, this.controller.deleteArticle());

    this.router.get("/searchProductInGoogle", this.controller.searchProductIngoogle());
  }
}
