import { check } from "../middleware/check";
import { CategoryController } from "../controller/categoryController";
import { Router } from "express";
import { IRouter } from "./RouterInterface";

export class CategoryRouter implements IRouter {
  public router: Router;
  private controller: CategoryController;
  public routerSubPath: string = "/category";

  constructor() {
    this.router = Router();
    this.controller = new CategoryController();
  }

  public registerRoutes(): void {
    this.router.get("/getAllCategories", this.controller.getAllCategories());
    
    this.router.get("/categories/:categoryId/articles", check, this.controller.getArticlesInCategory());
  }
}
