import { check } from "../middleware/check";
import { OrderManager } from "../controller/orderController";
import { Router } from "express";
import { IRouter } from "./RouterInterface";

export class OrderRouter implements IRouter {
  public router: Router;
  private controller: OrderManager;
  public routerSubPath: string = "/order";

  constructor() {
    this.router = Router();
    this.controller = new OrderManager();
    this.registerRoutes();
  }

  public registerRoutes(): void {
    this.router.post(
      "/addNewItemToOrder",
      check,
      this.controller.addArticleToShoppingCart()
    );

    this.router.get("/getItemsInCart", check, this.controller.getItemsInCart());

    this.router.put(
      "/updateProductQuantity",
      check,
      this.controller.updateItemQuantity()
    );

    this.router.delete(
      "/deleteItemFromShoppingCart",
      check,
      this.controller.deleteItemFromShoppingCart()
    );
  }
}
