import { describe, expect, it, test } from "@jest/globals";
import supertest from "supertest";

const baseUrl = "http://localhost:8000";

describe("test for categories", () => {
  describe("get all categories", () => {
    const response = supertest(baseUrl).get("/api/category/getAllCategories");
    it("should send a response status 200", async () => {
      const status = (await response).status;
      const expectedStatus = 200;
      expect(expectedStatus).toEqual(status);
    });

    it("should return moore than one category", async () => {
      expect((await response).body.length > 0);
    });
  });

  describe("get article in a certain catgeory", () => {
    const response = supertest(baseUrl)
      .get("/api/category/categories/3/articles")
      .accept("application/json");

    it("should get exactly get one article sotred in category Furniture ", async () => {
      const body = (await response).body
      expect(body.length).toEqual(1);
    });

    it("expect categoryId is 3", async () => {
      const body = (await response).body;
      expect(body[0].categoryid).toEqual(3);
    });

    it("expect name is Sofa", async () => {
      const body = (await response).body;
      expect(body[0].name).toEqual("Sofa");
    });
  });
});
